from checkui import *
from usercontroller import UserController
import gtk

uc = UserController()

class CashierUI(gtk.Window):
    """
    Currently the cashier UI will only have 2 buttons, check in and check out.
    """
    def __init__(self, operator):
        # 2 buttons: check in, check out.
        self.operator = operator
        gtk.Window.__init__(self)
        self.set_position(gtk.WIN_POS_CENTER)
        self.set_resizable(False)
        self.set_title("Cashier Control")

        # Layout
        vbox = gtk.VBox()
        tophbox = gtk.HBox()
        midhbox = gtk.HBox()
        downhbox = gtk.HBox()

        self.usernameEntry = gtk.Entry()
        self.usernameLabel = gtk.Label("Customer username:")
        checkinButton = gtk.Button("Check In")
        checkinButton.set_size_request(70, 30)
        checkoutButton = gtk.Button("Check Out")
        checkoutButton.set_size_request(70, 30)

        self.statusLabel = gtk.Label("")

        checkinButton.connect("clicked", self.check_in)
        checkoutButton.connect("clicked", self.check_out)

        tophbox.add(self.usernameLabel)
        tophbox.add(self.usernameEntry)
        midhbox.add(self.statusLabel)
        downhbox.add(checkoutButton)
        downhbox.add(checkinButton)
        vbox.add(tophbox)
        vbox.add(midhbox)
        vbox.add(downhbox)
        self.add(vbox)
        self.show_all()

        self.connect("destroy", self.on_destroy)

    def __get_username(self):
        text = self.usernameEntry.get_text()
        if text == "":
            return False
        else:
            test = uc.get_user_info(text)
            if test == None:
                return False
            else:
                return text

    def check_in(self, widget):
        """
        """
        customer = self.__get_username()
        if customer == False:
            self.statusLabel.set_text("Empty username or doesn't exist.")
        else:
            CheckInUI(customer, self.operator)

    def check_out(self, widget):
        """
        Brings up checkui's checkout ui.
        """
        customer = self.__get_username()
        if customer == False:
            self.statusLabel.set_text("Empty username or doesn't exist.")
        else:
            CheckOutUI(customer, self.operator)

    def on_destroy(self, widget):
        """
        Quit the whole programme. This means the cashier has finished the job of
        that day.
        """
        gtk.main_quit()
