from usercontroller import UserController
uc = UserController()

class LoginControl(object):
    """
    LoginControl controls which UI to bring up if authenticate is correct.
    """
    def control(self, username, password, staff=False):
        """
        Determines who should log into what UI system.
        """
        if staff == False:
            if uc.authenticate(username, password):
                import searchinterface
                searchinterface.SearchInterface()
                return True

            else:
                return False

        else:
            if uc.authenticate(username, password, 1):
                import staffinterface
                import cashier
                priv = uc.get_staff_privilege(username)
                if priv == 1:
                    cashier.CashierUI(username)
                    return True
                elif priv == 2:
                    staffinterface.StockerUI(username)
                    return True
                else:
                    return False
