import gtk
import gobject
from stockcontroller import StockController

sc = StockController()

class SearchInterface(gtk.Window):
    def __init__(self):
        gtk.Window.__init__(self)
        self.set_title("Search Interface")
        self.set_size_request(600, 300)
        self.set_position(gtk.WIN_POS_CENTER)
        self.set_resizable(True)
        self.connect("destroy", self.on_quit)

        # Vertical Box
        vbox = gtk.VBox()

        # Tips label for searching
        label = gtk.Label(
                "Type title directly in the table to search, close to quit")

        self.store = self.list_all()
        self.treeview = gtk.TreeView(self.store)
        self.treeview.set_rules_hint(True)
        self.create_columns(self.treeview)

        vbox.add(label)
        vbox.add(self.treeview)

        self.add(vbox)
        self.show_all()

    def create_columns(self, treeview):
        """Creating the columns"""
        rendererText = gtk.CellRendererText()

        column = gtk.TreeViewColumn("Title", rendererText, text=0)
        column.set_sort_column_id(0)
        self.treeview.append_column(column)

        rendererText = gtk.CellRendererText()
        column = gtk.TreeViewColumn("Barcode", rendererText, text=1)
        column.set_sort_column_id(0)
        self.treeview.append_column(column)

        rendererText = gtk.CellRendererText()
        column = gtk.TreeViewColumn("Status", rendererText, text=2)
        column.set_sort_column_id(0)
        self.treeview.append_column(column)

        rendererText = gtk.CellRendererText()
        column = gtk.TreeViewColumn("Fees per lease", rendererText, text=3)
        column.set_sort_column_id(0)
        self.treeview.append_column(column)

    def list_all(self):
        from parser import Parser
        parse = Parser()

        l = sc.list_all_dvd()
        if len(l) == 0:
            return None

        store = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_UINT, 
                gobject.TYPE_STRING, gobject.TYPE_DOUBLE)

        for i in range(len(l)):
            if l[i][3] == 0:
                out = "In Stock"
            else:
                out = "Out of Stock"

            store.append((
                l[i][0], 
                l[i][1], 
                out, 
                round(l[i][5] * parse.get_profit_rate(), 2)
                ))

        return store

    def on_quit(self, widget):
        from modules.loginwindow import LoginWindow
        LoginWindow()
        self.destroy()
