import gtk
from stockcontroller import StockController

sc = StockController()

class AdminUI(gtk.Window):
    """
    I don't plan on doing AdminUI for this project.

    Admin user can still be added by import usercontroller.
    """
    pass

class StockerUI(gtk.Window):
    def __init__(self, username):
        gtk.Window.__init__(self)
        self.set_position(gtk.WIN_POS_CENTER)
        self.connect("destroy", self.do_quit)
        self.set_title("Stock Interface")
        self.set_resizable(False)

        # Layout 
        buttonHBox = gtk.HBox()

        table = gtk.Table()

        titleLabel = gtk.Label("DVD Title:  ")
        self.titleEntry = gtk.Entry()

        barcodeLabel = gtk.Label("DVD Barcode:  ")
        self.barcodeEntry = gtk.Entry()

        priceLabel = gtk.Label("Price:      ")
        self.priceEntry = gtk.Entry()

        addButton = gtk.Button("Add")
        cancelButton = gtk.Button("Quit")

        # Add elements to layout

        table.attach(titleLabel, 0, 2, 0, 1)
        table.attach(self.titleEntry, 2, 4, 0, 1)

        table.attach(barcodeLabel, 0, 2, 1, 2)
        table.attach(self.barcodeEntry, 2, 4, 1, 2)

        table.attach(priceLabel, 0, 2, 2, 3)
        table.attach(self.priceEntry, 2, 4, 2, 3)

        buttonHBox.add(addButton)
        buttonHBox.add(cancelButton)
        table.attach(buttonHBox, 0, 4, 3, 4)

        self.add(table)

        # Signals
        self.priceEntry.connect("activate", self.do_add)
        addButton.connect("clicked", self.do_add)
        cancelButton.connect("clicked", self.do_quit)

        self.show_all()

    def do_add(self, widget):
        """
        Adder method for new DVDs. Barcode should be unique for all DVDs.
        """
        title = self.titleEntry.get_text()
        barcode = int(self.barcodeEntry.get_text())
        price = float(self.priceEntry.get_text())
        ret = sc.add_dvd(title, barcode, price)

        if ret is not True:
            dialog = gtk.Dialog("Error!", self, gtk.DIALOG_MODAL, 
                    (gtk.STOCK_OK, gtk.RESPONSE_CLOSE))
            msg = gtk.Label("Barcode Exists!")
            msg.show()
            dialog.vbox.pack_start(msg)
            dialog.run()
            dialog.destroy()
            self.barcodeEntry.set_text("")

        else:
            dialog = gtk.Dialog("Message", self, gtk.DIALOG_MODAL, 
                    (gtk.STOCK_OK, gtk.RESPONSE_OK))
            msg = gtk.Label("Success")
            msg.show()
            dialog.vbox.pack_start(msg)
            dialog.run()
            dialog.destroy()
            self.titleEntry.set_text("")
            self.barcodeEntry.set_text("")
            self.priceEntry.set_text("")

    def do_quit(self, widget):
        gtk.main_quit()
